/*
*/
#property copyright ""
#property link      ""

#define	IndicatorName	"aeDeMA"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_color2 Red


extern int		PeriodMA		= 12;
extern int		TypeMA		= 0;
extern string	_TypePrice	= "CLOSE 0,OPEN 1,HIGH 2,LOW 3,MEDIAN 4,TYPICAL 5,WEIGHTED 6";
extern int		TypePrice	= 0;
extern int		Count			= 500;

double ayMATrend[];
double aySignal[];


double	ayMALine[];
int		MALineCount;

int init() {
   SetIndexStyle(0, DRAW_LINE);SetIndexLabel(0, "MALine");
   SetIndexBuffer(0, ayMATrend);
   SetIndexStyle(1, DRAW_LINE);SetIndexLabel(1, "Signal");
   SetIndexBuffer(1, aySignal);
 
	IndicatorShortName(IndicatorName+"("+PeriodMA+")");

	MALineCount=PeriodMA*1.5+2;
	ArrayResize(ayMALine,MALineCount);

   return (0);
}

int deinit() {
	ArrayResize(ayMALine,0);
   return (0);
}

int start() {
	double	CurrMA;
	double	PrevMA;
	int		SignalTick=0;
	int		SignalRec=0;
	double	MAPrice;
	double	MALast;
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Trend Line ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
   int NewBars = IndicatorCounted();
   if (NewBars < 0) return (-1);
   if (NewBars > 0) NewBars--;
   int Counter = Bars - NewBars;
   if (Counter>Count) Counter=Count;
   Counter=MathMin(Counter, Bars - 2);
   
//   for (int Index = MathMin(Counter, Bars - 2); Index >= 0; Index--) {
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Trend Line ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
  	ArraySetAsSeries(ayMALine,true);
	for (int Index =Counter;Index>=0; Index--) {
      if (NewBars == 0) {
      }
   	for (int IxShift=ArraySize(ayMALine)-1;IxShift>0;IxShift--) ayMALine[IxShift]=ayMALine[IxShift-1];
   	ayMALine[0]=iMA(Symbol(), Period(), PeriodMA, 0, TypeMA, TypePrice, Index);
   	if((Counter-Index)>PeriodMA){
   		MAPrice=2*ayMALine[0]-iMAOnArray(ayMALine, 0, PeriodMA, 0, TypeMA, 0);

   		ayMATrend[Index]=MAPrice;
      }
	}
   return (0);
}

